# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from sbg_driver/SbgShipMotionStatus.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class SbgShipMotionStatus(genpy.Message):
  _md5sum = "a834637d2b283cc5378d30ef92fcf13a"
  _type = "sbg_driver/SbgShipMotionStatus"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# SBG Ellipse Messages
# SbgShipMotionStatus

# True after heave convergence time.
# False in following conditions:
# - Turn occurred and no velocity aiding is available
# - Heave reached higher/lower limits
# - If a step is detected and filter has to re-converge
# - If internal failure
bool heave_valid

# True if heave output is compensated for transient accelerations
bool heave_vel_aided

# True if the swell period is provided in this output
bool period_available

# True if the period returned is assumed to be valid or not.
bool period_valid"""
  __slots__ = ['heave_valid','heave_vel_aided','period_available','period_valid']
  _slot_types = ['bool','bool','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       heave_valid,heave_vel_aided,period_available,period_valid

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SbgShipMotionStatus, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.heave_valid is None:
        self.heave_valid = False
      if self.heave_vel_aided is None:
        self.heave_vel_aided = False
      if self.period_available is None:
        self.period_available = False
      if self.period_valid is None:
        self.period_valid = False
    else:
      self.heave_valid = False
      self.heave_vel_aided = False
      self.period_available = False
      self.period_valid = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_4B().pack(_x.heave_valid, _x.heave_vel_aided, _x.period_available, _x.period_valid))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      _x = self
      start = end
      end += 4
      (_x.heave_valid, _x.heave_vel_aided, _x.period_available, _x.period_valid,) = _get_struct_4B().unpack(str[start:end])
      self.heave_valid = bool(self.heave_valid)
      self.heave_vel_aided = bool(self.heave_vel_aided)
      self.period_available = bool(self.period_available)
      self.period_valid = bool(self.period_valid)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_4B().pack(_x.heave_valid, _x.heave_vel_aided, _x.period_available, _x.period_valid))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      _x = self
      start = end
      end += 4
      (_x.heave_valid, _x.heave_vel_aided, _x.period_available, _x.period_valid,) = _get_struct_4B().unpack(str[start:end])
      self.heave_valid = bool(self.heave_valid)
      self.heave_vel_aided = bool(self.heave_vel_aided)
      self.period_available = bool(self.period_available)
      self.period_valid = bool(self.period_valid)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_4B = None
def _get_struct_4B():
    global _struct_4B
    if _struct_4B is None:
        _struct_4B = struct.Struct("<4B")
    return _struct_4B
